/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
 package cours
{
	import flash.ui.Keyboard;
	import starling.events.KeyboardEvent;
	import starling.core.Starling;
	import starling.display.MovieClip;
	import starling.textures.TextureAtlas;
	import starling.utils.deg2rad;
	import flash.display.Bitmap;
	import starling.display.Image;
	import starling.textures.Texture;

	import starling.display.Sprite;
	import starling.events.Event;

	/**
	 * Utilisation du Framework 2D Starling.
	 * 
	 */
	public class GameAnim extends Sprite
	{
		
	    [Embed(source="../bin/logo.xml", mimeType="application/octet-stream")] 
	    public static const SpriteSheetXML:Class; 
		
		[Embed(source = "../bin/logo-as3.jpg")]
		private static const LogoAS3 : Class;
		
		[Embed(source="../bin/perso.xml", mimeType="application/octet-stream")] 
	    public static const SpriteSheetXMLPerso:Class; 
		
		[Embed(source = "../bin/perso-anim.png")]
		private static const PersoAnim : Class;
		
		private var mMovie : MovieClip;
		private var mMovieButcher : MovieClip;
		
		private var bPlay:Boolean;

		public function GameAnim()
		{
			// attend la fin de l'initialisation de la scène
			addEventListener(Event.ADDED_TO_STAGE, onAdded);
		}

		private function onAdded(e : Event) : void
		{
			//addOneLogo();
			
			// création d'un ou plusieurs animations de personnages
			// à partir d'une image (jog, png...).
			addTwologo();
			
		}

		private function addOneLogo() : void
		{
			// création d'un bitmap embarqué (fichier sprite sheet)
			var bitmap : Bitmap = new LogoAS3();

			// ajout d'une texture
			var texture : Texture = Texture.fromBitmap(bitmap);

			// création d'un fichier xml qui décrit les images du sprite
			var xml : XML = XML(new SpriteSheetXML());

			// création d'une texture (relie le sprite sheet et le xml)
			var sTextureAtlas : TextureAtlas = new TextureAtlas(texture, xml);

			// récupération des images running
			var frames : Vector.<Texture> = sTextureAtlas.getTextures("running");

			// création d'un movie clip exécuté à 40fps
			mMovie = new MovieClip(frames, 40);    
			mMovie.scaleX = -1;   
			mMovie.x = (stage.stageWidth - mMovie.width >> 1) + mMovie.width; 
			mMovie.y = stage.stageHeight - mMovie.height >> 1; 
			
			// affichage
			addChild(mMovie);
		}

		private function addTwologo() : void
		{
			// création d'un bitmap embarqué (fichier sprite sheet)
			var bitmap : Bitmap = new PersoAnim();

			// ajout d'une texture
			var texture : Texture = Texture.fromBitmap(bitmap);

			// création d'un fichier xml qui décrit les images du sprite
			var xml : XML = XML(new SpriteSheetXMLPerso());

			// création d'une texture (relie le sprite sheet et le xml)
			var sTextureAtlas : TextureAtlas = new TextureAtlas(texture, xml);
			
			// récupération des images running du garçon
			var frames : Vector.<Texture> = sTextureAtlas.getTextures("running_");

			// récupération des images du "policier"
			var framesButcher : Vector.<Texture> = sTextureAtlas.getTextures("french-butcher_");
			
			// création d'un movie clip exécuté à 40fps
			mMovie = new MovieClip(frames, 40);

			// création d'un movie clip exécuté à 25fps
			mMovieButcher = new MovieClip(framesButcher, 25);

			// positionnement des movieclip
			mMovie.x = stage.stageWidth - mMovie.width >> 1;
			mMovie.y = stage.stageHeight - mMovie.height >> 1;
			
			mMovieButcher.x = mMovie.x + mMovie.width - 50;
			mMovieButcher.y = mMovie.y;

			// affichage
			addChild(mMovie);
			addChild(mMovieButcher);
			
			// lance l'animation
			Starling.juggler.add ( mMovie ); 
			Starling.juggler.add ( mMovieButcher ); 
			
			// affiche la frame 5 pendant une durée de 2 secondes 
			/*mMovie.setFrameDuration(5, 2); 
			mMovieButcher.setFrameDuration(1, 10); */
			
			// pause ou stop de l'animation 
			//mMovie.pause(); 
			mMovie.stop(); 
			bPlay = false;
			
			// appuie sur une touche de votre clavier
			stage.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDown); 
			stage.addEventListener(KeyboardEvent.KEY_UP, onKeyUp);
			
			// écouteur sur chaque image par seconde
			stage.addEventListener(Event.ENTER_FRAME, onFrame);
		}
		
		
		private function onKeyDown(e : KeyboardEvent) : void
		{
			// appuie sur la touche droite ou gauche
			var state : int;
			if ( e.keyCode == Keyboard.RIGHT )
				state = 1;
			else if ( e.keyCode == Keyboard.LEFT )
				state = -1;
			else
				return;
			
			// positionnement du garçon
			if ( mMovie.scaleX == -1 )
				mMovie.x -= mMovie.width;
				
			bPlay = true;
				
			// changement de direction du garçon
			mMovie.scaleX = state;

			// positionnement du garçon
			if ( mMovie.scaleX == -1 )
				mMovie.x = mMovie.x + mMovie.width;
		} 
		
		private function onKeyUp(e : KeyboardEvent) : void
		{
			// appuie sur la touche droite ou gauche
			if ( e.keyCode == Keyboard.RIGHT || e.keyCode == Keyboard.LEFT)	bPlay = false;
				
		}
		
		/**
		 * Mise à jour toutes les images.
		 * 
		 */
		private function onFrame(e : Event) : void
		{
			if(bPlay)	mMovie.play();// rejoue l'animation
			else mMovie.pause();// animation en pause
		} 
		
	}
}